
%{
#include <stdio.h>
#include <strings.h>
#include "script.tab.h"
%}

%option noyywrap

%%

"print" { return PRINT; }
"store" { return STORE; }
";"     { return SEMI; } 
"("     { return OPAREN; }
")"     { return CPAREN; }

"+" { return PLUS; }
"-" { return MINUS; }
"*" { return MULT; }
"/" { return DIV; }

[A-Za-z]([A-Za-z]|[0-9])*   { 
                                     yylval.string_val = new char[sizeof(yytext)+1]; 
                                     strcpy(yylval.string_val,yytext);
                                     return VAR; 
                                 }
[0-9]+  { yylval.int_val = atoi(yytext); return NUM; }

[ \t\n]* {}
. { fprintf(stderr,"Error %s\n",yytext); exit(1); }

%%
void yyerror(char * str)
{
  fprintf(stderr,"error: %s\n",str);
  exit(1);
}
