/* C++ include stuff */
%{
#include <stdio.h>
#include <string.h>
  /* function prototypes */  
  int yyerror(char *s);
  int yylex(void);
%}

/* declare the union of all possible lexemes to be deposited in yyval */
%union {
  char* string_val; /* needed for variable names */
  int   int_val;    /* needed for numbers */
}

/* start symbol of grammar */
%start prog

 /* structural tokens */
%token PRINT STORE SEMI OPAREN CPAREN

 /* arithmetic tokens */
%left PLUS MINUS
%left MULT DIV

 /* tokens with variable lexemes */
%token <string_val> VAR
%token <int_val> NUM

%%

prog : stmt 
     | prog stmt
     ;

stmt : PRINT exp SEMI
     | STORE VAR exp SEMI
     ;

exp  : exp PLUS exp 
     | exp MINUS exp
     | exp MULT exp
     | exp DIV exp
     | OPAREN exp CPAREN
     | VAR
     | NUM
     ;

%%

/* a main function to drive the parser ... for testing purposes only */
int main(int argc, char **argv)
{
  if ((argc > 1) && (freopen(argv[1], "r", stdin) == NULL))
    {
      fprintf(stderr, "Could not open file!\n");
      exit(1);
    }
  
  yyparse();

  return 0;
}

